/*
AUTOR: MICROSIDE TECHNOLOGY S.A. DE C.V.
FECHA: MARZO 2023

  driver_test

  En esta práctica se demuestra el uso de ésta librería
  para controlar 2 motores utilizando el módulo de hardware
  DRIVER-X:

  El circuito:
    -- NANO-X --    |  -- DRIVER-X --
  - digital(~pwm) 9:     PIN IN1A
  - digital(~pwm) 5:     PIN IN2A
  - digital(~pwm) 3:     PIN IN1B
  - digital(~pwm) 6:     PIN IN2B

*/

// Incluye la libreria driver-x
#include "driver-x.h"

#define AIN1 9
#define AIN2 5
#define BIN1 3
#define BIN2 6

DRIVER_X motores;

void setup()
{
  // Asigna los pines a los motores A y B respectivamente
  motores.init(AIN1, AIN2, BIN1, BIN2);
  // Puede asignar los pines a los motores por separado
  // motores.initA(AIN1, AIN2);
  // motores.initB(BIN1, BIN2)
}

void loop()
{
  // Si los pines asignados no son PWM puede llamar a la funcion como:
  // motores.forwardA();
  // Los valores admitidos son 0-PWM_resolution
  // Donde PWM_resolution es la resolucion PWM de la tarjeta de desarrollo
  // en la NANO-X, Arduino Uno, Arduino Nano este valor es de 255
  motores.forwardA(128); //Mueve el motor A hacia adelante (vel = 128)
  motores.forwardB(128);
  delay(1000);
  motores.backwardA(200); //Gira el motor A hacia atras (vel = 200)
  motores.backwardB(200);
  delay(1000);
  motores.invertA(); //Invierte el sentido de giro del motor A
  delay(1000);
  motores.invertA();
  motores.invertB();
  delay(1000);
  motores.stopA(); //Detiene el giro del motor A
  delay(1000);
  motores.stopB();
  delay(1000);
}